//============================================================================

#pragma once
#include "ColorRgba.h"

//============================================================================
// Helper function

// Convert RGBA data to PVRTC1 4BPP format, with out without Alpha channel (still RGBA as input)
void CreatePVRTC_4BPP(void* dest, void *src, int width, int height, int alpha);
// Give the size of the output data (in byte)
int GetSizePVRTC_4BPP(int width, int height);

namespace Javelin
{
//============================================================================

	class AlphaBitmap;
	class RgbBitmap;
	class RgbaBitmap;
	
	class PvrTcEncoder
	{
	public:
		// Result must be large enough for bitmap.GetArea()/4 bytes
		static void EncodeAlpha2Bpp(void* result, const AlphaBitmap& bitmap);
		
		// Result must be large enough for bitmap.GetArea()/2 bytes
		static void EncodeAlpha4Bpp(void* result, const AlphaBitmap& bitmap);
		
		// Result must be large enough for bitmap.GetArea()/2 bytes
		static void EncodeRgb4Bpp(void* result, const RgbBitmap& bitmap);

		// Result must be large enough for bitmap.GetArea()/2 bytes
		static void EncodeRgb4Bpp(void* result, const RgbaBitmap& bitmap);

		// Result must be large enough for bitmap.GetArea()/2 bytes
		static void EncodeRgba4Bpp(void* result, const RgbaBitmap& bitmap);

	private:
		static unsigned GetMortonNumber(int x, int y);
	};
	
//============================================================================
}
//============================================================================
